<template>
    <v-table :columns="columns" :ds="items" v-model:value="selectList" :pageSize="filter.pageSize || 20"
        :totalRecord="totalRecord" @page="onPageChange" :current="current" @pageSizeChange="onChangePageSize"
        v-model:search="filter.search" @onSearch="onSearch"  width="1900px" @onEdit="onEdit" :isDelete="false"
        namespace="user" >
       
    </v-table>
</template>

<script>
import {mapActions,  mapGetters } from 'vuex';
import VTable from '@/components/VTable';
import { ElMessage } from 'element-plus';


export default {
    name: 'VUserList',
    components: {
        VTable,
    },
    created() {
        this.onFetchAll();
    },
    computed: {
        ...mapGetters('UserList', ['items', 'totalRecord'])
    },
    data: () => ({
        filter: {
            pageSize: 20,
            pageNumber: 1,
            search: ''
        },
        current: 1,
        showDialog: false,
        selectList: [],
        columns: [
            {
                field: 'fullName',
                name: 'Name',
                allowFillter: ''
            },
            {
                field: 'username',
                name: 'User Name'
            },
            {
                field: 'email',
                name: 'Email'
            },
            {
                field: 'phoneNumber',
                name: 'Phone Number'
            },
            {
                field: 'position',
                name: 'Position'
            },
            {
                field: 'departmentId',
                name: 'Department'
            },
            {
                field: 'telegramId',
                name: 'Telegram'
            },
            {
                field: 'assignUserRole',
                name: 'Assign User Role'
            },

        ]
    }),
    methods: {
        onChangePageSize(value) {
            this.filter = { ...this.filter, ...{ pageSize: value } };
            this.onFetchAll();
        },
        onFetchAll() {
            try {
                this.selectList = [];
            } catch (error) {
                ElMessage({
                    showClose: true,
                    message: error,
                })
            }
        },
        ...mapActions('UserList'),
        onPageChange(page) {
            this.current = page;
            this.filter = { ...this.filter, ...{ pageNumber: (page - 1) } }
            this.onFetchAll();
        },
        onSearch() {
            this.onFetchAll();
        },
        onEdit(val) {
            this.$router.push({ path: `/setting/user/edit/${val}` });
        },
    },
}
</script>